VERSION 5.00
Begin VB.Form DragPicForm 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "DragPic"
   ClientHeight    =   4425
   ClientLeft      =   1140
   ClientTop       =   1500
   ClientWidth     =   3660
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   Picture         =   "DragPic.frx":0000
   ScaleHeight     =   4425
   ScaleWidth      =   3660
   ShowInTaskbar   =   0   'False
   Begin VB.PictureBox picHidden 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   765
      Left            =   2040
      ScaleHeight     =   51
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   51
      TabIndex        =   2
      Top             =   2160
      Visible         =   0   'False
      Width           =   765
   End
   Begin VB.PictureBox picMask 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   795
      Left            =   2040
      Picture         =   "DragPic.frx":357E2
      ScaleHeight     =   53
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   101
      TabIndex        =   1
      Top             =   1320
      Visible         =   0   'False
      Width           =   1515
   End
   Begin VB.PictureBox picMeow 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   795
      Left            =   2040
      Picture         =   "DragPic.frx":36328
      ScaleHeight     =   53
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   101
      TabIndex        =   0
      Top             =   480
      Visible         =   0   'False
      Width           =   1515
   End
End
Attribute VB_Name = "DragPicForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'From the book Rod Stephens "Ready-to-run Visual Basic Code Library", Wiley Press
Option Explicit

#If Win32 Then
    Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal dwRop As Long) As Long
#Else
    Private Declare Function BitBlt Lib "GDI" (ByVal hDestDC As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As Integer, ByVal XSrc As Integer, ByVal YSrc As Integer, ByVal dwRop As Long) As Integer
#End If

Private Const MERGEPAINT = &HBB0226
Private Const SRCAND = &H8800C6
Private Const SRCCOPY = &HCC0020

' Variables for positioning the image.
Dim OldX As Single
Dim OldY As Single
Dim CurX As Single
Dim CurY As Single
Dim OffsetX As Single
Dim OffsetY As Single
Dim PicWid As Single
Dim PicHgt As Single
Dim Xmax As Single
Dim Ymax As Single
Dim Dragging As Boolean
' Draw the picture at (CurX, CurY).
Private Sub DrawPicture()
    ' Fix the part of the image that was covered.
    BitBlt hDC, _
        OldX, OldY, PicWid, PicHgt, _
        picHidden.hDC, OldX, OldY, SRCCOPY
    OldX = CurX
    OldY = CurY

    ' Paint on the new image.
    BitBlt hDC, _
        CurX, CurY, PicWid, PicHgt, _
        picMask.hDC, 0, 0, MERGEPAINT
    BitBlt hDC, _
        CurX, CurY, PicWid, PicHgt, _
        picMeow.hDC, 0, 0, SRCAND

    ' Update the display.
    Refresh
End Sub

' Get the picture's size and initialize things.
Private Sub Form_Load()
    picHidden.Picture = Picture
    picHidden.Visible = False

    ScaleMode = vbPixels
    picMeow.ScaleMode = vbPixels
    picMask.ScaleMode = vbPixels

    PicWid = picMeow.ScaleWidth
    PicHgt = picMeow.ScaleHeight
    Xmax = ScaleWidth - PicWid
    Ymax = ScaleHeight - PicHgt
    OldX = 30
    OldY = 30
    CurX = 30
    CurY = 30

    DrawPicture
End Sub

' Start dragging the picture.
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' See if this point corresponds to
    ' a black point on the mask.
    If picMask.Point(X - CurX, Y - CurY) <> vbBlack Then Exit Sub

    ' Start dragging.
    Dragging = True
    OffsetX = CurX - X
    OffsetY = CurY - Y
End Sub

' Continue dragging.
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not Dragging Then Exit Sub
    
    CurX = X + OffsetX
    CurY = Y + OffsetY
    
    If CurX < 0 Then CurX = 0
    If CurX > Xmax Then CurX = Xmax
    If CurY < 0 Then CurY = 0
    If CurY > Ymax Then CurY = Ymax
    
    DrawPicture
End Sub


' Stop dragging.
Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dragging = False
End Sub

